﻿using System.Collections;
using System.Collections.Generic;
using Unity.XR.Qiyu;
using UnityEngine;

namespace Unity.XR.Qiyu.Space
{
    /// <summary>
    /// use this script for manager space anchor auto update position and position
    /// </summary>
    public class QiyuSpaceAnchorUpdater : QiyuSingletion<QiyuSpaceAnchorUpdater>
    {
        public override void Awake()
        {
            base.Awake();
            if (QiyuPlatform.IsAndroid)
            {
                UnityEngine.XR.InputDevices.GetDeviceAtXRNode(UnityEngine.XR.XRNode.Head).subsystem.boundaryChanged += On_Recenter;
            }
        }
        public void OnDestroy()
        {
            if (QiyuPlatform.IsAndroid)
            {
                UnityEngine.XR.InputDevices.GetDeviceAtXRNode(UnityEngine.XR.XRNode.Head).subsystem.boundaryChanged -= On_Recenter;
            }
        }

        private void On_Recenter(UnityEngine.XR.XRInputSubsystem obj)
        {
            Debug.Log("Update Anchor On Recenter!");
            foreach (var watch_anchor in watch_anchors)
            {
                Debug.Log("Update Anchor:" + watch_anchor.id);
                Vector3 point1 = watch_anchor.rotation * Vector3.forward + watch_anchor.position;
                Vector3 point2 = watch_anchor.position;
                point1 = QiyuSpaceManager.Relocator_ParseToUnityPoint(point1);
                point2 = QiyuSpaceManager.Relocator_ParseToUnityPoint(point2);
                Vector3 pos = point2;
                Quaternion rot = Quaternion.LookRotation(point1 - point2).normalized;
                watch_anchor.attachTarget.transform.position = pos;
                watch_anchor.attachTarget.transform.rotation = rot;
            }
        }

        List<SpaceAnchor> watch_anchors = new List<SpaceAnchor>();
        public void WatchAnchor(SpaceAnchor anchor, GameObject obj)
        {
            anchor.attachTarget = obj;
            watch_anchors.Add(anchor);
            Debug.Log($"WatchAnchor id:{anchor.id}");
        }

        public void UnWatchAnchor(SpaceAnchor anchor)
        {
            watch_anchors.Remove(anchor);
        }

        public void ClearAnchors()
        {
            watch_anchors.Clear();
        }
    }
}