﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
namespace Unity.XR.Qiyu.Space
{
    public enum SpaceEntityType
    {
        Other = 0,
        WallFace = 1,
        Floor = 2,
        Ceiling = 3,
        Door = 4,
        Window = 5,
        Desk = 6,
        Chair = 7
    }

    public class SpaceAnchor
    {
        public long id;
        public Vector3 position;
        public Quaternion rotation;

        public GameObject attachTarget;
    }

    public class SpaceRoomPart : SpaceAnchor
    {
        public SpaceEntityType tag;
        public Vector3 scale;
    }

    public class SpaceRoomCube : SpaceRoomPart
    {

    }

    public class SpaceRoomQuad : SpaceRoomPart
    {
        public List<Vector2> boundary = new List<Vector2>();
    }

    public class SpaceRoomLayout : SpaceRoomPart
    {
        public SpaceRoomQuad floor;
        public SpaceRoomQuad ceiling;
        public List<SpaceRoomQuad> wallFaces = new List<SpaceRoomQuad>();
    }
}
